<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>LibGE: src/AGDerivationTree.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="cropped-BDS-Logo-1.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibGE
   &#160;<span id="projectnumber">0.31.0</span>
   </div>
   <div id="projectbrief">A c++ GE implementation</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">AGDerivationTree.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_a_g_derivation_tree_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Tree.h -*- C++ -*-</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#ifndef _AGDERIVATIONTREE_H_</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#define _AGDERIVATIONTREE_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">/* This class implements an n-ary derivation tree containing AGSymbol*.      */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">//#include &quot;libGEdefs.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">//#include&lt;vector&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_tree_8h.html">Tree.h</a>&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_a_g_symbol_8h.html">AGSymbol.h</a>&quot;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_phenotype_8h.html">Phenotype.h</a>&quot;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div><div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="_a_g_derivation_tree_8h.html#af1603f0c0d74c57dab97d421b1a43941">   16</a></span>&#160;<span class="keyword">enum</span> <a class="code" href="_a_g_derivation_tree_8h.html#af1603f0c0d74c57dab97d421b1a43941">TraversalReason</a> {<a class="code" href="_a_g_derivation_tree_8h.html#af1603f0c0d74c57dab97d421b1a43941a1e1a4aba20a5a009e616cbc8fad33ac7">CLEAR</a>,<a class="code" href="_a_g_derivation_tree_8h.html#af1603f0c0d74c57dab97d421b1a43941ab107229d44d042caa8ab8df4c8acaa1f">PRINT</a>,<a class="code" href="_a_g_derivation_tree_8h.html#af1603f0c0d74c57dab97d421b1a43941a87358f51692388b9925666590b391e21">PHENOTYPE</a>};</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">using namespace </span>std;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="_a_g_derivation_tree_8h.html#aea8835f130330807224a71891dcf0c86">   20</a></span>&#160;<span class="keyword">typedef</span> <a class="code" href="class_tree.html">Tree&lt;AGSymbol*&gt;</a> <a class="code" href="_a_g_derivation_tree_8h.html#aea8835f130330807224a71891dcf0c86">AGTree</a>;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div><div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="class_a_g_derivation_tree.html">   22</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_a_g_derivation_tree.html">AGDerivationTree</a>{</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;  </div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <a class="code" href="class_a_g_derivation_tree.html">AGDerivationTree</a>(<span class="keywordtype">bool</span> recycleNodes=<span class="keyword">false</span>);</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        <a class="code" href="class_a_g_derivation_tree.html">AGDerivationTree</a>(<span class="keyword">const</span> <a class="code" href="class_a_g_derivation_tree.html">AGDerivationTree</a> &amp;copy);</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="class_a_g_derivation_tree.html">AGDerivationTree</a>();</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isRecycling() <span class="keyword">const</span>;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setTree(<a class="code" href="class_tree.html">AGTree</a>* newTree);</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keyword">virtual</span> <a class="code" href="class_tree.html">AGTree</a>* getTree() <span class="keyword">const</span>;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> clearTree();</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> clearSubtreeBelow(<a class="code" href="class_tree.html">AGTree</a>&amp; node, <span class="keywordtype">bool</span> recycleNodes);</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> printTree();</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadPhenotype(<a class="code" href="class_phenotype.html">Phenotype</a>* pheno);</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    </div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="class_a_g_derivation_tree.html#a2146a0df4c4d64ea61e5760c058a0d4c">   37</a></span>&#160;        <a class="code" href="class_tree.html">AGTree</a>* <a class="code" href="class_a_g_derivation_tree.html#a2146a0df4c4d64ea61e5760c058a0d4c">tree</a>;</div><div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="class_a_g_derivation_tree.html#a17717edd750503ba3a1ffcf32daf0333">   38</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="class_a_g_derivation_tree.html#a17717edd750503ba3a1ffcf32daf0333">recycle</a>;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keyword">static</span> <span class="keywordtype">void</span> traverseTree(<a class="code" href="class_tree.html">AGTree</a>&amp; currentNode, <a class="code" href="_a_g_derivation_tree_8h.html#af1603f0c0d74c57dab97d421b1a43941">TraversalReason</a> reason, <span class="keywordtype">bool</span> recycleNodes, <a class="code" href="class_phenotype.html">Phenotype</a>* pheno=NULL);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;};</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="a_phenotype_8h_html"><div class="ttname"><a href="_phenotype_8h.html">Phenotype.h</a></div></div>
<div class="ttc" id="a_a_g_derivation_tree_8h_html_af1603f0c0d74c57dab97d421b1a43941a1e1a4aba20a5a009e616cbc8fad33ac7"><div class="ttname"><a href="_a_g_derivation_tree_8h.html#af1603f0c0d74c57dab97d421b1a43941a1e1a4aba20a5a009e616cbc8fad33ac7">CLEAR</a></div><div class="ttdef"><b>Definition:</b> AGDerivationTree.h:16</div></div>
<div class="ttc" id="aclass_phenotype_html"><div class="ttname"><a href="class_phenotype.html">Phenotype</a></div><div class="ttdef"><b>Definition:</b> Phenotype.h:29</div></div>
<div class="ttc" id="a_a_g_derivation_tree_8h_html_af1603f0c0d74c57dab97d421b1a43941ab107229d44d042caa8ab8df4c8acaa1f"><div class="ttname"><a href="_a_g_derivation_tree_8h.html#af1603f0c0d74c57dab97d421b1a43941ab107229d44d042caa8ab8df4c8acaa1f">PRINT</a></div><div class="ttdef"><b>Definition:</b> AGDerivationTree.h:16</div></div>
<div class="ttc" id="a_a_g_symbol_8h_html"><div class="ttname"><a href="_a_g_symbol_8h.html">AGSymbol.h</a></div></div>
<div class="ttc" id="aclass_a_g_derivation_tree_html_a2146a0df4c4d64ea61e5760c058a0d4c"><div class="ttname"><a href="class_a_g_derivation_tree.html#a2146a0df4c4d64ea61e5760c058a0d4c">AGDerivationTree::tree</a></div><div class="ttdeci">AGTree * tree</div><div class="ttdef"><b>Definition:</b> AGDerivationTree.h:37</div></div>
<div class="ttc" id="a_a_g_derivation_tree_8h_html_af1603f0c0d74c57dab97d421b1a43941a87358f51692388b9925666590b391e21"><div class="ttname"><a href="_a_g_derivation_tree_8h.html#af1603f0c0d74c57dab97d421b1a43941a87358f51692388b9925666590b391e21">PHENOTYPE</a></div><div class="ttdef"><b>Definition:</b> AGDerivationTree.h:16</div></div>
<div class="ttc" id="a_a_g_derivation_tree_8h_html_af1603f0c0d74c57dab97d421b1a43941"><div class="ttname"><a href="_a_g_derivation_tree_8h.html#af1603f0c0d74c57dab97d421b1a43941">TraversalReason</a></div><div class="ttdeci">TraversalReason</div><div class="ttdef"><b>Definition:</b> AGDerivationTree.h:16</div></div>
<div class="ttc" id="a_tree_8h_html"><div class="ttname"><a href="_tree_8h.html">Tree.h</a></div></div>
<div class="ttc" id="a_a_g_derivation_tree_8h_html_aea8835f130330807224a71891dcf0c86"><div class="ttname"><a href="_a_g_derivation_tree_8h.html#aea8835f130330807224a71891dcf0c86">AGTree</a></div><div class="ttdeci">Tree&lt; AGSymbol * &gt; AGTree</div><div class="ttdef"><b>Definition:</b> AGDerivationTree.h:20</div></div>
<div class="ttc" id="aclass_a_g_derivation_tree_html"><div class="ttname"><a href="class_a_g_derivation_tree.html">AGDerivationTree</a></div><div class="ttdef"><b>Definition:</b> AGDerivationTree.h:22</div></div>
<div class="ttc" id="aclass_a_g_derivation_tree_html_a17717edd750503ba3a1ffcf32daf0333"><div class="ttname"><a href="class_a_g_derivation_tree.html#a17717edd750503ba3a1ffcf32daf0333">AGDerivationTree::recycle</a></div><div class="ttdeci">bool recycle</div><div class="ttdef"><b>Definition:</b> AGDerivationTree.h:38</div></div>
<div class="ttc" id="aclass_tree_html"><div class="ttname"><a href="class_tree.html">Tree</a></div><div class="ttdef"><b>Definition:</b> Tree.h:17</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
